#include "Sprites_Animations.h"
#include "Sprites_TileID.h"

/** Animations **/

// Player animations
SpriteAnim SpriteAnim_PlayerMoveDown_Left;
SpriteAnim SpriteAnim_PlayerMoveDown_Right;
SpriteAnim SpriteAnim_PlayerMoveRight_Left;
SpriteAnim SpriteAnim_PlayerMoveRight_Right;
SpriteAnim SpriteAnim_PlayerMoveUp_Left;
SpriteAnim SpriteAnim_PlayerMoveUp_Right;
SpriteAnim SpriteAnim_PlayerMoveLeft_Left;
SpriteAnim SpriteAnim_PlayerMoveLeft_Right;

/** Functions **/

/*
* Initialize all sprite anim variables
*/
void SpritesAnimations_Initialization()
{
    // Anim player move down
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveDown_Left, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveDown_Left, 0, SPRITES_TILESET16x16_PLAYER_DOWN_WALK0_LEFT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveDown_Left, 1, SPRITES_TILESET16x16_PLAYER_DOWN_WALK1_LEFT, 15);
    
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveDown_Right, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveDown_Right, 0, SPRITES_TILESET16x16_PLAYER_DOWN_WALK0_RIGHT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveDown_Right, 1, SPRITES_TILESET16x16_PLAYER_DOWN_WALK1_RIGHT, 15);

    // Anim player move right
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveRight_Left, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveRight_Left, 0, SPRITES_TILESET16x16_PLAYER_RIGHT_WALK0_LEFT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveRight_Left, 1, SPRITES_TILESET16x16_PLAYER_RIGHT_WALK1_LEFT, 15);
    
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveRight_Right, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveRight_Right, 0, SPRITES_TILESET16x16_PLAYER_RIGHT_WALK0_RIGHT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveRight_Right, 1, SPRITES_TILESET16x16_PLAYER_RIGHT_WALK1_RIGHT, 15);

    // Anim player move left
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveLeft_Left, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveLeft_Left, 0, SPRITES_TILESET16x16_PLAYER_LEFT_WALK0_LEFT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveLeft_Left, 1, SPRITES_TILESET16x16_PLAYER_LEFT_WALK1_LEFT, 15);
    
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveLeft_Right, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveLeft_Right, 0, SPRITES_TILESET16x16_PLAYER_LEFT_WALK0_RIGHT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveLeft_Right, 1, SPRITES_TILESET16x16_PLAYER_LEFT_WALK1_RIGHT, 15);

    // Anim player move up
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveUp_Left, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveUp_Left, 0, SPRITES_TILESET16x16_PLAYER_UP_WALK0_LEFT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveUp_Left, 1, SPRITES_TILESET16x16_PLAYER_UP_WALK1_LEFT, 15);
    
    SpriteAnim_IntializeSpriteAnim(&SpriteAnim_PlayerMoveUp_Right, 2);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveUp_Right, 0, SPRITES_TILESET16x16_PLAYER_UP_WALK0_RIGHT, 15);
    SpriteAnim_SetSpriteAnimFrame(&SpriteAnim_PlayerMoveUp_Right, 1, SPRITES_TILESET16x16_PLAYER_UP_WALK1_RIGHT, 15);
}