#include "Lever.h"
#include "../../Engine/Movables/Movable.h"
#include "../PatternManager/PatternManager.h"

#include "../../Engine/Maps/Assets/Maps_Tilesets.h"

// Levers array
Lever LeverArray[NB_LEVERS];

/**
 * Activates this lever.
 */
void Lever_Activate(Lever* _Lever)
{
    if (!_Lever->active)
    {
        _Lever->active = TRUE;

        if(_Lever->leverMovable != NULL)
        {
            Sprite_SetSpriteData(&_Lever->leverMovable->leftSprite, _Lever->leverMovable->leftSprite.ID, SPRITES_TILESET16x16_PLAYER_UP_RIGHT, FALSE);
            Sprite_SetSpriteData(&_Lever->leverMovable->rightSprite, _Lever->leverMovable->rightSprite.ID, SPRITES_TILESET16x16_PLAYER_UP_RIGHT, TRUE);
            PatternManager_Next(_Lever);
        }
    }
}

/**
 * Deactivates this lever.
 */
void Lever_Deactivate(Lever* _Lever)
{
    _Lever->active = FALSE;

    if(_Lever->leverMovable != NULL)
    {
        // Movable_SetSpriteAnim(_Lever->leverMovable, &SpriteAnim_LeverDeactivate_Left, &SpriteAnim_LeverDeactivate_Right);
        //Sprite_SetSpriteData(_Lever->leverMovable, _Lever->leverMovable->leftSprite->ID, TILEID HERE, FALSE);
    }
}

/* 
* Set lever at specified ID with specified movable
*/
void Lever_InitLever(UINT8 _ID, Movable* _Movable)
{
    if (_ID < NB_LEVERS)
    {
        LeverArray[_ID].active = FALSE;
        LeverArray[_ID].leverMovable = _Movable;
        LeverArray[_ID].id = _ID;
    }
}