#ifndef DEF_LEVER

#define DEF_LEVER

#define LEVER_A 0
#define LEVER_B 1
#define LEVER_C 2
#define LEVER_D 3

#define NB_LEVERS 4

#include "../../Engine/Movables/Movable.h"

struct Lever
{
    // ID of lever (using defines)
    UINT8 id;

    // Defines if the lever is active
    UINT8 active;

    // Movable used to represent the lever in the game
    Movable* leverMovable;
};
typedef struct Lever Lever;

/**
 * Activates this lever.
 */
void Lever_Activate(Lever* _Lever);

/**
 * Deactivates this lever.
 */
void Lever_Deactivate(Lever* _Lever);

/* 
* Set lever at specified ID with specified movable
*/
void Lever_InitLever(UINT8 _ID, Movable* _Movable);

/** Exposed Variables **/

// Levers array
extern Lever LeverArray[NB_LEVERS];

#endif