#ifndef DEF_TURNMANAGER

#define DEF_TURNMANAGER

#define NB_MAX_PLAYERS 3

#include "../../Engine/Dialogs/DialogManager.h"

/** Exposed Functions **/

/*
* Draw next player turn data as player ID and pattern and load a level randomly
*/
void TurnManager_GoToNextTurn();

/*
* Go to game over screen
*/
void TurnManager_GameOver();

/*
* Called each frame
*/
void TurnManager_Update();

/** Static Functions **/

/*
* Draw next player ID and next pattern
*/
static void TurnManager_DrawNextPlayerAndPattern();

/*
* Load a random level (delayed task)
*/
static void TurnManager_RequestRandomLevelLoading();

/*
* Get dialog sentence corresponding to current player ID
*/
static DialogSentence* TurnManager_GetDialogSentenceFromPlayerID();

/** Attributes **/

// Current player ID
extern UINT8 CurrentPlayerID;

// Is turn ready to be played
extern UINT8 IsGameTurnReady;

#endif