#include <gb/gb.h>
#include <rand.h>

#include "Engine/Game/Game.h"

#include "Engine/Inputs/InputManager.h"
#include "Engine/Movables/Movable.h"
#include "Engine/Maps/MapLoader.h"
#include "Engine/Tags_Layers/Tags.h"

#include "Engine/Dialogs/DialogManager.h"
#include "Engine/Audio/MusicPlayer.h"

#include "Engine/Scroll/ScrollManager.h"

#include "Game/Character/Character.h"
#include "Game/TurnManager/TurnManager.h"
#include "Game/Helpers/TimerManager.h"
#include "Game/PatternManager/PatternManager.h"

void CheckInput();
void EnableMovement();
void OnDialogClosed(Dialog* _Dialog);
void Update();

//UINT8 playerCanMove = TRUE;
UWORD seed;

/*
* Main function of program. Entry point
*/
void main()
{
    // Init rand
    seed = DIV_REG;
    seed |= (UWORD)DIV_REG << 8;
    initarand(seed);

    // Play music
    disable_interrupts();
    MusicPlayer_Play(Song0, 6, TRUE);

    TimerManager_CreateTimer(5);

    // Initialize game
    Game_Initialize();

    // Bind update callbacks
    Game_BindPostUpdateCallback(Update);
}

/*
* Called each frame
*/
void Update()
{
    TurnManager_Update();

    CheckInput();
}

/*
* React to inputs
*/
void CheckInput()
{
    // Local variables
    Vector translation = {0, 0};
    Dialog testDialog;

    // Load map
    if (InputManager_IsButtonPressed(J_B))
    {
        // Test dialog
        /*
        testDialog.activeSentence = &DialogSentence_Pattern0;

        if (!DialogManager_DialogExists())
        {
            playerCanMove = FALSE;
            DialogManager_Open(&testDialog, OnDialogClosed);
        }
        else
        {
            DialogManager_Next();
        }
        */
        PatternManager_Reset();
    }

    Character_CheckInput();
}